<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);

// checkIfNoPhpContentsReceive();
// print_r($postdata);
// die();
if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);


function getbook($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id, $from_date, $to_date, $limit, $offset)
{
    $sql = "SELECT  count(*) as total_rows FROM  library_management  where institution_id =? AND branch_id = ?";
    $array_params = [$institution_id,$branch_id];
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
    

    if ($limit == 'all') {

        $sql_session = "SELECT * FROM  library_management  where institution_id =? AND branch_id = ? AND book_name LIKE ?";
        $array_params = [$institution_id,$branch_id, '%' . $search_string . '%'];
        
        // if ($branch_id == 'all') {
        //     $sql_session .= "";
        // } else if ($branch_id !=  null  && $branch_id != 'all') {
        //     $sql_session .= " AND branch_id = ? ";
        //     $array_params[] = $branch_id;
        // }

        if ($class_id == 'all') {
            $sql_session .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql_session .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }

        if ($subject_id == 'all') {
            $sql_session .= "";
        } else if ($subject_id !=  null  && $subject_id != 'all') {
            $sql_session .= " AND subject_id = ? ";
            $array_params[] = $subject_id;
        }


        if ($search_string != null) {
            $sql_session .= " AND book_name LIKE ? ";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql_session .= " AND date_added BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }


        $sql_session .=  "order by date_added desc, time_created desc";
    } else {
        $sql_session = "SELECT * FROM library_management WHERE institution_id = ? AND branch_id = ? AND book_name LIKE ?";
        $array_params = [$institution_id,$branch_id, '%' . $search_string . '%'];
        
        // if ($branch_id == 'all') {
        //     $sql_session .= "";
        // } else if ($branch_id !=  null  && $branch_id != 'all') {
        //     $sql_session .= " AND branch_id = ? ";
        //     $array_params[] = $branch_id;
        // }

        if ($class_id == 'all') {
            $sql_session .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql_session .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }

        if ($subject_id == 'all') {
            $sql_session .= "";
        } else if ($subject_id !=  null  && $subject_id != 'all') {
            $sql_session .= " AND subject_id = ? ";
            $array_params[] = $subject_id;
        }
        if ($search_string != null) {
            $sql_session .= " AND (book_name LIKE ? OR author LIKE ? OR genre LIKE ?)";
            $search_term = '%' . $search_string . '%';
            $array_params[] = $search_term;
            $array_params[] = $search_term;
            $array_params[] = $search_term;
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql_session .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }
        $sql_session .= " order by date_added desc, time_created desc ";
        $sql_session .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql_session);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();



    $array_return = [];

    foreach ($session_rows as $rows) {

      

        // Check if class_id is not null before calling getClass function
$class_info = null;
if (!empty($rows['class_id'])) {
    $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
}

// Check if subject_id is not null before calling getSubject function
$subject_info = null;
if (!empty($rows['subject_id'])) {
    $subject_info = getSubject($conn_rjllearning_specific, $institution_id, $rows['subject_id']);
}

        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $array_return[] = array(
            'book_id' => $rows['id'],
            'book_name' => $rows['book_name'],
        );
    }

    if (count($session_rows) < 50) {

        return array('total_rows' => $totalrows, 'library_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'library_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_book") {
    
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    if(isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
        $branch_id = trim($postdata['branch_id']);
    } else {
        $branch_id = null;
    }
     if(isset($postdata['subject_id']) and !empty($postdata['subject_id']) and trim($postdata['subject_id'])) {
        $subject_id = trim($postdata['subject_id']);
    } else {
        $subject_id = null;
    }

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }


    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = "all";
    }
    
     if (isset($postdata['from_date']) and !empty($postdata['from_date'])) {
        $from_date = trim($postdata['from_date']);
    } else {
        $from_date = null;
    }
    if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
        $to_date = trim($postdata['to_date']);
    } else {
        $to_date = null;
    }
    
    if ($from_date > $to_date) {
    errorreturn('Invalid Date format');
    }
    $limit = $postdata['limit'];


    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getbook($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id,$from_date,$to_date, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getbook($conn_rjllearning_specific, $institution_id, $search_string, $branch_id, $subject_id, $class_id,$from_date,$to_date, $limit, null);
        successreturn($success);
    }
}

